routes/web.php
<?php

use App\Http\Controllers\QuestionController;
use App\Http\Controllers\QuestionsOptionsController;
use App\Http\Controllers\ResultsController;
use App\Http\Controllers\TopicController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', [TopicController::class, 'index'])->name('dashboard');

Route::resource('users', UserController::class);
Route::resource('topics', TopicController::class);
Route::resource('questions', QuestionController::class);
Route::resource('options', QuestionsOptionsController::class);
Route::get('/results/score', [ResultsController::class, 'score'])->name('results.score');
Route::resource('results', ResultsController::class);


require __DIR__ . '/auth.php';

app/Models/Question.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Collection;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Database\Eloquent\Relations\HasOne;

class Question extends Model
{
    protected $table = 'questions';
    protected $fillable = ['text', 'topic_id'];

    public function options(): HasMany
    {
        return $this->hasMany('App\Models\Option', 'question_id', 'id');
    }

    public function correctOptionsCount(): int
    {
        return $this->options()->where('correct', 1)->count();
    }

    public function correctOptions(): Collection
    {
        return $this->options()->where('correct', 1)->get();
    }

    public function topic(): HasOne
    {
        return $this->hasOne('App\Models\Topic', 'id', 'topic_id');
    }
}

app/Http/Controllers/QuestionController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StoreQuestionRequest;
use App\Http\Requests\UpdateQuestionRequest;
use App\Models\Option;
use App\Models\Question;
use App\Models\Topic;
use Illuminate\Contracts\Foundation\Application;
use Illuminate\Contracts\View\Factory;
use Illuminate\Contracts\View\View;
use Illuminate\Http\RedirectResponse;
use Illuminate\Routing\Redirector;

class QuestionController extends Controller
{
    public function __construct()
    {
        $this->middleware('admin');
    }

    public function index(): Factory|View|Application
    {
        $questions = Question::all();

        return view('questions.index', ['questions' => $questions]);
    }

    public function store(StoreQuestionRequest $request): Redirector|Application|RedirectResponse
    {
        $topicID = $request->input('topic');
        $questionText = $request->input('question');
        $optionArray = $request->input('options');
        $correctOptions = $request->input('correct');
        $binaryOptions = $request->input('binary');

        $question = new Question();
        $question->topic_id = $topicID;
        $question->text = $questionText;
        $question->save();

        $questionToAdd = Question::latest()->first();
        $questionID = $questionToAdd->id;

        foreach ($optionArray as $index => $opt) {
            $option = new Option();
            $option->question_id = $questionID;
            $option->option = $opt;
            foreach ($correctOptions as $correctOption) {
                if ($correctOption == $index + 1) {
                    $option->correct = 1;
                }
            }
            if (!empty($binaryOption)) {
                foreach ($binaryOptions as $binaryOption) {
                    if ($binaryOption == $index + 1) {
                        $option->binary = 1;
                    }
                }
            }

            $option->save();
        }

        return redirect()->back();
    }

    public function show(int $id): Factory|View|Application
    {
        $question = Question::find($id);

        return view('questions.show', ['question' => $question]);
    }

    public function edit(int $id): Factory|View|Application
    {
        $question = Question::find($id);
        $topics = Topic::all();

        return view('questions.edit', ['question' => $question, 'topics' => $topics]);
    }

    public function update(UpdateQuestionRequest $request, int $id): Redirector|Application|RedirectResponse
    {
        $topicID = $request->input('topic_id');
        $questionText = $request->input('text');

        $question = Question::find($id);
        $question->topic_id = $topicID;
        $question->text = $questionText;
        $question->save();

        return redirect(route('questions.index'));
    }

    public function destroy(int $id): Redirector|Application|RedirectResponse
    {
        $question = Question::find($id);
        $question->delete();

        return redirect(route('questions.index'));
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

resources/views/questions/edit.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Edit Question') }}
        </h2>
    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="d-flex" id="wrapper">
                    <div class="container">
                        @if($question)
                            @if ($errors->any())
                                <div class="alert alert-danger">
                                    <ul>
                                        @foreach ($errors->all() as $error)
                                            <li>{{ $error }}</li>
                                        @endforeach
                                    </ul>
                                </div>
                            @endif
                            <div class="form-group">
                                <hr>

                                <form method="POST" action="{{route('questions.update', $question->id)}}">
                                    @csrf
                                    @method('put')
                                    <div class="panel panel-default">
                                        <div class="panel-body">
                                            <div class="row">
                                                <div class="col-md-12 form-group">
                                                    <select class="form-control" name="topic_id">
                                                        @foreach($topics as $topic)
                                                            <option
                                                                value="{{$topic->id}}" {{($topic->id == $question->topic_id) ? 'selected' : ''}}>{{$topic->title}}</option>
                                                        @endforeach
                                                    </select>
                                                </div>
                                            </div>
                                            <div class="row">
                                                <div class="col-md-12 form-group">
                                                    <label for="text" class="control-label">Question
                                                        text</label>
                                                    <textarea class="form-control" required placeholder=""
                                                              name="text"
                                                              cols="50"
                                                              rows="10">{{$question->text}}</textarea>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <input class="btn btn-primary" type="submit" value="Update">
                                </form>
                            </div>
                        @else
                            <h1>No Question</h1>
                        @endif
                    </div>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/questions/index.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('All Questions') }}
        </h2>
    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="d-flex" id="wrapper">
                    <div class="container">
                        <div class="row">
                            <div class="col-md-12 mt-4">
                                <table class="table table-bordered table-striped datatable">
                                    <thead>
                                    <tr>
                                        <th>Topic</th>
                                        <th>Question text</th>
                                        <th>More</th>
                                    </tr>
                                    </thead>

                                    <tbody>
                                    @foreach($questions as $question)
                                        <tr>
                                            <td>
                                                @if($question->topic)
                                                    {{$question->topic->title}}
                                                @endif
                                            </td>
                                            <td>
                                                @if(strlen($question->text) > 100)
                                                    {{substr($question->text, 0, 100)}}...
                                            </td>
                                            @else
                                                {{$question->text}}
                                            @endif
                                            <td>
                                                <a href="{{route('questions.show', $question->id)}}"
                                                   class="btn btn-xs btn-primary">View</a>
                                                <a href="{{route('questions.edit', $question->id)}}"
                                                   class="btn btn-xs btn-warning">Edit</a>
                                                <form class="inline-flex"
                                                      action="{{route('questions.destroy', $question->id)}}"
                                                      method="post">
                                                    @csrf
                                                    @method('delete')
                                                    <button class="btn btn-xs btn-danger" type="submit">Delete</button>
                                                </form>
                                            </td>
                                        </tr>
                                    @endforeach
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/questions/show.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Create new Quiz') }}
        </h2>
    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="d-flex" id="wrapper">
                    <div class="container">
                        @if($question)
                            <div class="row">
                                <div class="col-md-12 mt-4">
                                    <h3 class="page-title">All Questions</h3>
                                    <table class="table table-bordered table-striped datatable">
                                        <thead>
                                        <tr>
                                            <th>Topic</th>
                                            <th>Question text</th>
                                        </tr>
                                        </thead>
                                        <tbody>
                                        <tr>
                                            <td>{{$question->topic->title}}</td>
                                            <td>{{$question->text}}</td>
                                        </tr>
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        @else
                            <h1>No Question</h1>
                        @endif
                    </div>
                </div>
            </div>
        </div>
    </div>
    </div>
</x-app-layout>